﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Compdfkit_Tools.PDFControl
{
    /// <summary>
    /// AddCertificationDialog.xaml 的交互逻辑
    /// </summary>
    public partial class AddCertificationDialog : Window
    {
        private AddCertificationControl addCertificationControl = null;
        private AddCustomCertificationControl addCustomCertificationControl = null;
        private AddExistedCertificationControl addExistedCertificationControl = null;
        private SaveCerficateControl saveCerficateControl = null;
        public event EventHandler<CertificateAccess> FillSignatureEvent;


        public AddCertificationDialog()
        {
            InitializeComponent();
            addCertificationControl = new AddCertificationControl();
            BodyBd.Child = addCertificationControl;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            addCertificationControl.ContinueEvent -= ContinueEvent;
            addCertificationControl.ContinueEvent += ContinueEvent;
        }

        private void ContinueEvent(object sender, CreateCertificationMode e)
        {
            if(e == CreateCertificationMode.AddExistedCertification)
            {
                addExistedCertificationControl = new AddExistedCertificationControl();
                BodyBd.Child = addExistedCertificationControl;
                this.Height = addExistedCertificationControl.Height + 35;
                this.Width = addExistedCertificationControl.Width + 20;
                 
                addExistedCertificationControl.CancelEvent += CancelEvent;
                addExistedCertificationControl.FillSignatureEvent -= AddExistedCertificationControl_FillSignatureEvent;
                addExistedCertificationControl.FillSignatureEvent += AddExistedCertificationControl_FillSignatureEvent;


            }
            else if(e == CreateCertificationMode.AddCustomCertification)
            {
                addCustomCertificationControl = new AddCustomCertificationControl();
                BodyBd.Child = addCustomCertificationControl;
                this.Height = addCustomCertificationControl.Height + 35;
                this.Width = addCustomCertificationControl.Width + 20;

                addCustomCertificationControl.ContinueEvent -= ContinueEvent;
                addCustomCertificationControl.ContinueEvent += ContinueEvent;

                addCustomCertificationControl.CancelEvent -= CancelEvent;
                addCustomCertificationControl.CancelEvent += CancelEvent;
            }
            else if (e == CreateCertificationMode.SaveCertificate)
            {
                saveCerficateControl = new SaveCerficateControl();
                saveCerficateControl.CertificateInfo = addCustomCertificationControl.certificateInfo;
                BodyBd.Child = saveCerficateControl;
                this.Height = saveCerficateControl.Height + 20;
                this.Width = saveCerficateControl.Width + 20;
            }
        }

        private void AddExistedCertificationControl_FillSignatureEvent(object sender, CertificateAccess e)
        {
            Close();
            FillSignatureEvent?.Invoke(sender, e);
        }

        private void CancelEvent(object sender, EventArgs e)
        {
            addCertificationControl = new AddCertificationControl();
            BodyBd.Child = addCertificationControl;
            this.Height = addCertificationControl.Height + 35;
            this.Width = addCertificationControl.Width + 20;
            addCertificationControl.ContinueEvent -= ContinueEvent;
            addCertificationControl.ContinueEvent += ContinueEvent;
        }
    }
}
