using System.Collections.Specialized;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows.Controls;

namespace Compdfkit_Tools.DigitalSignature.VerifyDigitalSignatureControl
{
    public partial class DigitalSignatureValiditySummaaryControl : UserControl, INotifyPropertyChanged
    {
        private string _validitySummaryString;
        public string ValiditySummaryString
        {
            get => _validitySummaryString;
            set => UpdateProper(ref _validitySummaryString, value);
        }
        public DigitalSignatureValiditySummaaryControl()
        {
            InitializeComponent();
            DataContext = this;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void UpdateProper<T>(ref T properValue,
            T newValue,
            [CallerMemberName] string properName = "")
        {
            if (object.Equals(properValue, newValue))
                return;

            properValue = newValue;
            OnPropertyChanged(properName);
        }

        protected void OnPropertyChanged([CallerMemberName] string propertyName = "") =>
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
    }
}